import { ExtensionContext, TreeDataProvider, EventEmitter, TreeItem, Event, window, TreeItemCollapsibleState, Uri, commands, workspace, TextDocumentContentProvider, CancellationToken, ProviderResult } from 'vscode';
import * as path from 'path';

interface IEntry {
	name: string;
	type: string;
}

export class ConnectionNode {

	constructor(private _name:string, private _uri:string) {
	}

	public get name(): string {
		return this._name;
	}

	public get uri(): string {
		return this._name;
    }
}

export class ConnectionModel {

	public get roots(): Thenable<ConnectionNode[]> {
        let list : ConnectionNode[] = [
            new ConnectionNode("swdev", "foobar"),
            new ConnectionNode("swint", "foobar")
        ];

        return new Promise((c, e) => c(list));
	}

	public getChildren(node: ConnectionNode): Thenable<ConnectionNode[]> {
        return new Promise((c, e) => []);
	}
}

export class ConnectionProvider implements TreeDataProvider<ConnectionNode>, TextDocumentContentProvider {

	private _onDidChangeTreeData: EventEmitter<any> = new EventEmitter<any>();
	readonly onDidChangeTreeData: Event<any> = this._onDidChangeTreeData.event;

	private model: ConnectionModel;

	public getTreeItem(element: ConnectionNode): TreeItem {
		return {
			label: element.name,
			collapsibleState: void 0,
			command: {
				command: 'openConnection',
				arguments: [element.uri],
				title: 'Open Connection'
			}
		};
	}

	public getChildren(element?: ConnectionNode): ConnectionNode[] | Thenable<ConnectionNode[]> {
		if (!element) {
			if (!this.model) {
				this.model = new ConnectionModel();
			}

			return this.model.roots;
		}

		return [];
    }
    
    public provideTextDocumentContent(uri: Uri, token: CancellationToken): ProviderResult<string> {
		return "nix";
	}
}